Name:           racket
Version:        7.9
Release:    1%{?dist}
Summary:        General purpose programming language

License:        MIT AND Apache-2.0 AND LGPLv3 AND MIT-Modern-Variant
URL:            https://racket-lang.org
Source0:        https://mirror.racket-lang.org/installers/%{version}/%{name}-%{version}-src.tgz
Patch1: racket-configure-c99.patch

ExcludeArch: %{arm} s390x ppc64le

BuildRequires: make
BuildRequires: gcc

BuildRequires:  chrpath

BuildRequires:  libffi-devel

BuildRequires:  gtk3

BuildRequires: cairo
BuildRequires: pango
BuildRequires: libpng
BuildRequires: libjpeg-turbo
BuildRequires: glib2

BuildRequires:  desktop-file-utils

BuildRequires: git

Requires:       racket-minimal = %{version}-%{release}
Requires:       racket-pkgs = %{version}-%{release}
Recommends:     racket-doc = %{version}-%{release}

%description
Racket is a general-purpose programming language as well as
the world's first ecosystem for developing and deploying new
languages. Make your dream language, or use one of the dozens
already available.

%prep

%autosetup -p1

rm -r src/bc/foreign/libffi

%build
cd src

%ifarch %{ix86}
  %set_build_flags
  export CFLAGS=$(echo $CFLAGS | sed -e "s/-mfpmath=sse *//")
%endif

%configure \
%ifarch %{arm} s390x
        --disable-generations \
%endif
        --enable-pthread \
        --enable-shared \
        --enable-libffi \
        --disable-libs \
        --disable-strip

%make_build

%install
%make_install -C src

rm %{buildroot}%{_bindir}/mred
rm %{buildroot}%{_bindir}/mred-text
ln -s gracket %{buildroot}%{_bindir}/mred
ln -s gracket-text %{buildroot}%{_bindir}/mred-text

chrpath --delete %{buildroot}%{_bindir}/racket
chrpath --delete %{buildroot}%{_libdir}/racket/gracket

rm %{buildroot}%{_libdir}/*.la

sed -i "s#%{buildroot}##g" %{buildroot}/%{_datadir}/applications/*.desktop

desktop-file-validate %{buildroot}/%{_datadir}/applications/*.desktop

for i in $(find %{buildroot}/%{_datadir}/doc/racket/ -name '*.html'); do
  sed -i "s#%{buildroot}##g" $i
done

chmod -x %{buildroot}%{_libdir}/racket/starter-sh


%package        minimal
Summary:        A minimal Racket installation
Requires:       racket-collects = %{version}-%{release}
%description    minimal
Racket's core runtime

%package        collects
Summary:        Racket's core collections libraries
BuildArch:      noarch
%description    collects
Libraries providing Racket's core functionality

%package        pkgs
Summary:        Racket package collections
Requires:       gtk3
Requires:       cairo
Requires:       pango
Requires:       libpng
Requires:       glib2
Requires:       libjpeg-turbo
Requires:       racket-minimal = %{version}-%{release}
BuildArch:      noarch
%description    pkgs
Additional packages and libraries for Racket

%package        devel
Summary:        Development files for Racket
Requires:       racket-minimal = %{version}-%{release}
%description    devel
Files needed to link against Racket.

%package        doc
Summary:        Documentation files for Racket
BuildArch:      noarch
%description    doc
A local installation of the Racket documentation system.

%files
%license src/LICENSE*.txt
%{_bindir}/drracket
%{_bindir}/gracket
%{_bindir}/gracket-text
%{_bindir}/mred-text
%{_bindir}/mred
%{_bindir}/mzc
%{_bindir}/mzpp
%{_bindir}/mzscheme
%{_bindir}/mztext
%{_bindir}/pdf-slatex
%{_bindir}/plt-games
%{_bindir}/plt-help
%{_bindir}/plt-r5rs
%{_bindir}/plt-r6rs
%{_bindir}/plt-web-server
%{_bindir}/scribble
%{_bindir}/setup-plt
%{_bindir}/slatex
%{_bindir}/slideshow
%{_bindir}/swindle
%{_datadir}/applications/

%files collects
%license src/LICENSE*.txt
%{_datadir}/racket/collects

%files minimal
%license src/LICENSE*.txt
%{_bindir}/racket
%{_bindir}/raco
%{_libdir}/racket
%{_libdir}/libracket3m-%{version}.so
%dir %{_datadir}/racket/
%{_datadir}/racket/links.rktd
%{_datadir}/racket/pkgs/racket-lib
%{_datadir}/man/man1/racket*
%{_datadir}/man/man1/raco*
%dir %{_sysconfdir}/racket/
%config %{_sysconfdir}/racket/config.rktd

%files pkgs
%license src/LICENSE*.txt
%{_datadir}/racket
%{_datadir}/man/man1/drracket*
%{_datadir}/man/man1/gracket*
%{_datadir}/man/man1/mred*
%{_datadir}/man/man1/mzc*
%{_datadir}/man/man1/mzscheme*
%{_datadir}/man/man1/plt-help*
%{_datadir}/man/man1/setup-plt*
%exclude %{_datadir}/racket/links.rktd
%exclude %dir %{_datadir}/racket/pkgs/racket-lib
%exclude %dir %{_datadir}/racket/collects

%files devel
%license src/LICENSE-*.txt
%{_includedir}/racket
%{_libdir}/libracket3m.so

%files doc
%license src/LICENSE*.txt
%{_datadir}/doc/racket

%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.9-1
- initial build
